package
{
	import mx.core.UIComponent;

	public class UserMousePointer 
	{
		public var targetX : Number = 0; 
		public var targetY : Number = 0; 
		public var velX : Number = 0; 
		public var velY : Number = 0; 
		public var mouseClip : MouseClip; 
		public var damping : Number = 0.1; 
		public var spring : Number = 0.6; 
		
		public function UserMousePointer(container : UIComponent)
		{
			mouseClip = new MouseClip(); 
			container.addChild(mouseClip); 
						
			
			targetX = 0; 
			targetY = 0; 
			velX = 0; 
			velY = 0; 
		}
		
		public function update() : void 
		{
			velX *= spring; 
			velY *= spring; 
			
			var diffx : Number = targetX - mouseClip.x; 
			var diffy : Number = targetY - mouseClip.y; 
			
			diffx *= damping; 
			diffy *= damping; 
			
			velX+=diffx; 
			velY+=diffy; 
			
			mouseClip.x +=velX; 
			mouseClip.y +=velY; 

		}

		public function set x(value : Number ) : void
		{ 
			targetX = value; 
		}
		public function set y(value : Number ) : void
		{
			targetY = value;
		}
		public function set userName (name : String) : void
		{
			mouseClip.username_txt.text = name; 		
		}
		
	}
}